diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/PriorityQueue.java b/game/core/src/main/java/net/minecraft/core/current/wire/PriorityQueue.java
index 5f38cce11..30b00cf1b 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/PriorityQueue.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/PriorityQueue.java
@@ -7,7 +7,7 @@ import java.util.AbstractQueue;
 import java.util.Arrays;
 import java.util.Iterator;
 
-class PriorityQueue extends AbstractQueue<Node> {
+public class PriorityQueue extends AbstractQueue<Node> {
 
 	private static final int OFFSET = -BlockLogicWireRedstone.SIGNAL_MIN;
 
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/SimpleQueue.java b/game/core/src/main/java/net/minecraft/core/current/wire/SimpleQueue.java
index 0fcef5f66..405861d9c 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/SimpleQueue.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/SimpleQueue.java
@@ -3,7 +3,7 @@ package net.minecraft.core.current.wire;
 import java.util.AbstractQueue;
 import java.util.Iterator;
 
-class SimpleQueue extends AbstractQueue<WireNode> {
+public class SimpleQueue extends AbstractQueue<WireNode> {
 
 	private WireNode head;
 	private WireNode tail;
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java
index b2bb579e0..86c6fa7bd 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java
@@ -7,7 +7,7 @@ package net.minecraft.core.current.wire;
  * 
  * @author Space Walker
  */
-class WireConnection {
+public class WireConnection {
 
 	/** The connected wire. */
 	final WireNode wire;
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java
index a1309f169..4725ac1a7 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java
@@ -1,12 +1,15 @@
 package net.minecraft.core.current.wire;
 
+import net.minecraft.core.block.BlockLogicRubyglassConduit;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.current.wire.WireHandler.Directions;
 import net.minecraft.core.current.wire.WireHandler.NodeProvider;
+import net.minecraft.core.util.helper.Side;
 
 import java.util.Arrays;
 import java.util.function.Consumer;
 
-class WireConnectionManager {
+public class WireConnectionManager {
 
 	/** The owner of these connections. */
 	final WireNode owner;
@@ -44,8 +47,15 @@ class WireConnectionManager {
 			clear();
 		}
 
-		boolean belowIsConductor = nodes.getNeighbor(owner, Directions.DOWN).isConductor();
-		boolean aboveIsConductor = nodes.getNeighbor(owner, Directions.UP).isConductor();
+		//tried my best to keep original AltCurrent naming schemes when changing code here
+
+		Node ownerDown = nodes.getNeighbor(owner, Directions.DOWN);
+		boolean belowIsConductor = ownerDown.isConductor();
+
+		Node ownerUp = nodes.getNeighbor(owner, Directions.UP);
+		boolean aboveIsConductor = ownerUp.isConductor();
+		// Check if the block directly above the bottom wire is an open conduit facing down
+		boolean aboveIsOpenDown = isConduitOpenTowards(ownerUp, Directions.DOWN);
 
 		for (int iDir = 0; iDir < Directions.HORIZONTAL.length; iDir++) {
 			Node neighbor = nodes.getNeighbor(owner, iDir);
@@ -57,19 +67,35 @@ class WireConnectionManager {
 			}
 
 			boolean sideIsConductor = neighbor.isConductor();
+			int iOppDir = Directions.iOpposite(iDir);
+
+			//looking downwards logic
+			boolean blockedDown = sideIsConductor ||
+					isConduitOpenTowards(ownerDown, iDir) ||
+					isConduitOpenTowards(neighbor, Directions.UP);
 
-			if (!sideIsConductor) {
+			if (!blockedDown) {
 				Node node = nodes.getNeighbor(neighbor, Directions.DOWN);
 
 				if (node.isWire()) {
-					add(node.asWire(), iDir, belowIsConductor, true);
+					boolean offerDown = belowIsConductor ||
+							(ownerDown.state.is(Blocks.RUBYGLASS_CONDUIT) && !isConduitOpenTowards(ownerDown, iDir));
+					add(node.asWire(), iDir, offerDown, true);
 				}
 			}
-			if (!aboveIsConductor) {
+
+			//looking upwards logic
+			boolean blockedUp = aboveIsConductor ||
+					aboveIsOpenDown ||
+					isConduitOpenTowards(neighbor, iOppDir);
+
+			if (!blockedUp) {
 				Node node = nodes.getNeighbor(neighbor, Directions.UP);
 
 				if (node.isWire()) {
-					add(node.asWire(), iDir, true, sideIsConductor);
+					boolean acceptUp = sideIsConductor ||
+							(neighbor.state.is(Blocks.RUBYGLASS_CONDUIT) && !isConduitOpenTowards(neighbor, iOppDir));
+					add(node.asWire(), iDir, true, acceptUp);
 				}
 			}
 		}
@@ -79,6 +105,29 @@ class WireConnectionManager {
 		}
 	}
 
+	/**
+	 * Checks if a node is a Rubyglass Conduit and if a specific directional port is open.
+	 * @param node The node to check
+	 * @param iDir The Alternate Current direction we are querying
+	 * @return true if the node is a conduit AND the port facing iDir is open
+	 */
+	private boolean isConduitOpenTowards(Node node, int iDir) {
+		if (node.state.is(Blocks.RUBYGLASS_CONDUIT)) {
+			Side face = Side.NONE;
+            face = switch (iDir) {
+                case Directions.WEST -> Side.WEST;
+                case Directions.NORTH -> Side.NORTH;
+                case Directions.EAST -> Side.EAST;
+                case Directions.SOUTH -> Side.SOUTH;
+                case Directions.DOWN -> Side.BOTTOM;
+                case Directions.UP -> Side.TOP;
+                default -> face;
+            };
+			return face != Side.NONE && BlockLogicRubyglassConduit.isSideOpen(node.state.get(), face);
+		}
+		return false;
+	}
+
 	private void clear() {
 		Arrays.fill(heads, null);
 
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
index 6884d9b05..61f8c1841 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireHandler.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.current.wire;
 
+import net.minecraft.core.block.BlockLogicRubyglassConduit;
 import net.minecraft.core.block.BlockLogicWireRedstone;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
@@ -754,6 +755,32 @@ public class WireHandler {
                 continue;
             }
 
+            //conduit logic
+            if (neighboringNode.state.is(Blocks.RUBYGLASS_CONDUIT)) {
+                int cData = neighboringNode.state.get();
+
+                Side conduitFace = getSide(iDir);
+
+                if (BlockLogicRubyglassConduit.isSideOpen(cData, conduitFace)) {
+                    int cStrength = cData / BlockLogicRubyglassConduit.STATE_COUNT;
+                    int convertedStrength = BlockLogicRubyglassConduit.signalConverter(cStrength, true);
+
+                    //step down the signal strength when passing from conduit to wire
+                    convertedStrength = Math.max(0, convertedStrength - 1);
+
+                    //if signal is less than current power, set to 0
+                    if (convertedStrength < wire.currentPower) {
+                        convertedStrength = 0;
+                    }
+
+                    if (convertedStrength > maxExternalPower) {
+                        maxExternalPower = convertedStrength;
+                    }
+                }
+                //this continue took me hours to find. I hate my life
+                continue;
+            }
+
             if (neighboringNode.isConductor() && hasDirectSignalTo(wire, neighboringNode, Directions.iOpposite(iDir))) {
                 maxExternalPower = POWER_MAX;
             }
@@ -769,9 +796,9 @@ public class WireHandler {
         }
     }
 
-    private static @NotNull Side getSideFromDirection(int iDirection) {
+    private static @NotNull Side getSide(int iDir) {
         Side wireSide = Side.NONE;
-        wireSide = switch (iDirection) {
+        wireSide = switch (iDir) {
             case Directions.WEST -> Side.WEST;
             case Directions.NORTH -> Side.NORTH;
             case Directions.EAST -> Side.EAST;
@@ -818,6 +845,10 @@ public class WireHandler {
         for (int iDir : Directions.I_EXCEPT[except]) {
             Node neighbor = getNeighbor(node, iDir);
 
+            if (neighbor.state.is(Blocks.WIRE_REDSTONE) || neighbor.state.is(Blocks.RUBYGLASS_CONDUIT)) {
+                continue;
+            }
+
             if (neighbor.isSignalSource() && neighbor.state.hasDirectSignal(this.world, neighbor.pos, Directions.ALL[iDir])) {
                 return true;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java
index b949ee832..0f8529fca 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireNode.java
@@ -17,7 +17,7 @@ import org.slf4j.Logger;
  *
  * @author Space Walker
  */
-class WireNode extends Node {
+public class WireNode extends Node {
     private static final Logger LOGGER = LogUtils.getLogger();
 
     final WireConnectionManager connections;
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java b/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java
index ade1e452a..5c61fc059 100644
--- a/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WorldHelper.java
@@ -8,7 +8,7 @@ import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
-class WorldHelper {
+public class WorldHelper {
 
     private static final int Y_MIN = 0;
 
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
index 3a9aa57b1..6d0139818 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
@@ -6,6 +6,7 @@ import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
 import net.minecraft.core.data.registry.recipe.RecipeRegistry;
 import net.minecraft.core.data.registry.recipe.entry.*;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemBucket;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.data.gamerule.GameRule;
 import net.minecraft.core.data.gamerule.GameRules;
@@ -174,6 +175,24 @@ public class Registries extends Registry<Registry<?>> {
                 new ItemStack(Items.TOOL_SWORD_DIAMOND, 1, -1),
                 new ItemStack(Items.TOOL_SWORD_STEEL, 1, -1)));
 
+        // Find every single ItemBucket currently registered in the game
+        List<ItemBucket> allBuckets = new ArrayList<>();
+        for (Item item : Item.itemsList) {
+            if (item instanceof ItemBucket bucket) {
+                allBuckets.add(bucket);
+            }
+        }
+
+        // Dynamically register ItemGroups for all bucket states
+        for (NamespaceID stateId : ItemBucket.getRegisteredStateIds()) {
+            if (ItemBucket.STATE_EMPTY.equals(stateId)) continue;
+            List<ItemStack> variations = new ArrayList<>();
+            for (ItemBucket bucket : allBuckets) {
+                variations.add(ItemBucket.createRecipeInput(bucket, stateId));
+            }
+            ITEM_GROUPS.register(stateId.namespace() + ":" + stateId.value() + "_buckets", variations);
+        }
+
         if (RECIPES == null) new RecipeRegistry();
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/RecipeSymbol.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/RecipeSymbol.java
index a6e35927b..297c4c08a 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/RecipeSymbol.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/RecipeSymbol.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.data.registry.recipe;
 
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.Tag;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.item.ItemStack;
 
@@ -154,19 +156,39 @@ public class RecipeSymbol {
         return null;
     }
 
-    public boolean matches(ItemStack stack){
-        if(stack == null) return false;
+    public boolean matches(ItemStack stack) {
+        if (stack == null) return false;
         List<ItemStack> stacks = resolve();
-        boolean found = false;
+
         for (ItemStack resolvedStack : stacks) {
-            boolean foundId = resolvedStack.itemID == stack.itemID;
-            boolean foundMeta = resolvedStack.getMetadata() == -1 || resolvedStack.getMetadata() == stack.getMetadata();
-            if (foundId && foundMeta) {
-                found = true;
-                break;
+            if (resolvedStack.itemID != stack.itemID) continue;
+            if (resolvedStack.getMetadata() != -1 && resolvedStack.getMetadata() != stack.getMetadata()) continue;
+
+            CompoundTag resolvedData = resolvedStack.getData();
+            if (resolvedData.getValue().isEmpty()) return true;
+
+            if (isNBTPresentAndEqual(resolvedData, stack.getData())) return true;
+        }
+        return false;
+    }
+
+    /**
+     * Checks if all tags in the requirement are present in the tagToCompare tag
+     * If present, the values of the tags must be equal to return true
+     * @param requirement The requirement tag
+     * @param tagToCompare The tag to compare
+     * @return True if all tags are present and equal, false otherwise
+     */
+    private boolean isNBTPresentAndEqual(CompoundTag requirement, CompoundTag tagToCompare) {
+        for (String key : requirement.getValue().keySet()) {
+            Tag<?> requirementTag = requirement.getTag(key);
+            Tag<?> comparrisonTag = tagToCompare.getTag(key);
+
+            if (comparrisonTag == null || !comparrisonTag.equals(requirementTag)) {
+                return false;
             }
         }
-        return found;
+        return true;
     }
 
     public char getSymbol() {
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java
index 548e63057..c8796b640 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java
@@ -2,6 +2,7 @@ package net.minecraft.core.data.registry.recipe.entry;
 
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
+import net.minecraft.core.item.IItemContainer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.ContainerCrafting;
 
@@ -35,9 +36,38 @@ public abstract class RecipeEntryCrafting<I,O> extends RecipeEntryBase<I,O,Void>
 
     public abstract boolean matchesQuery(SearchQuery query);
 
+    public boolean consumesContainer() {
+        return false;
+    }
+
+    public ItemStack[] onCraftResult(ContainerCrafting containerCrafting) {
+        ItemStack[] returnStack = new ItemStack[9];
+        for (int i = 0; i < containerCrafting.getContainerSize(); i++) {
+            ItemStack itemstack1 = containerCrafting.getItem(i);
+            if (itemstack1 == null) {
+                continue;
+            }
+
+            ItemStack gridStackSnapshot = ItemStack.copyItemStack(itemstack1);
+            containerCrafting.removeItem(i, 1);
+
+            if (!consumesContainer()) {
+
+                if (gridStackSnapshot.getItem() instanceof IItemContainer customContainer) {
+                    if (customContainer.hasContainerItem(gridStackSnapshot)) {
+                        containerCrafting.setItem(i, customContainer.getContainerItemStack(gridStackSnapshot));
+                    }
+                }
+                else if (gridStackSnapshot.getItem().hasContainerItem()) {
+                    assert gridStackSnapshot.getItem().getContainerItem() != null;
+                    containerCrafting.setItem(i, new ItemStack(gridStackSnapshot.getItem().getContainerItem()));
+                }
+            }
+        }
+        return returnStack;
+    }
+
     public abstract ItemStack getCraftingResult(ContainerCrafting containerCrafting);
 
     public abstract int getRecipeSize();
-
-    public abstract ItemStack[] onCraftResult(ContainerCrafting containerCrafting);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java
index 2a9c91fb3..b15a81821 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShaped.java
@@ -9,6 +9,7 @@ import net.minecraft.core.data.registry.recipe.RecipeNamespace;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.adapter.RecipeCraftingShapedJsonAdapter;
 import net.minecraft.core.data.registry.recipe.adapter.RecipeJsonAdapter;
+import net.minecraft.core.item.IItemContainer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.ContainerCrafting;
 
@@ -193,19 +194,8 @@ public class RecipeEntryCraftingShaped extends RecipeEntryCrafting<RecipeSymbol[
     }
 
     @Override
-    public ItemStack[] onCraftResult(ContainerCrafting containerCrafting) {
-        ItemStack[] returnStack = new ItemStack[9];
-        for (int i = 0; i < containerCrafting.getContainerSize(); i++) {
-            ItemStack itemstack1 = containerCrafting.getItem(i);
-            if (itemstack1 == null) {
-                continue;
-            }
-            containerCrafting.removeItem(i, 1);
-            if (!consumeContainerItem && itemstack1.getItem().hasContainerItem()) {
-                containerCrafting.setItem(i, new ItemStack(itemstack1.getItem().getContainerItem()));
-            }
-        }
-        return returnStack;
+    public boolean consumesContainer() {
+        return this.consumeContainerItem;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShapeless.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShapeless.java
index c2cee07e5..d1f1b88bb 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShapeless.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCraftingShapeless.java
@@ -8,6 +8,7 @@ import net.minecraft.core.data.registry.recipe.RecipeNamespace;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.adapter.RecipeCraftingShapelessJsonAdapter;
 import net.minecraft.core.data.registry.recipe.adapter.RecipeJsonAdapter;
+import net.minecraft.core.item.IItemContainer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.ContainerCrafting;
 
@@ -140,25 +141,6 @@ public class RecipeEntryCraftingShapeless extends RecipeEntryCrafting<List<Recip
         return false;
     }
 
-    @Override
-    public ItemStack[] onCraftResult(ContainerCrafting containerCrafting){
-        ItemStack[] returnStack = new ItemStack[9];
-        for(int i = 0; i < containerCrafting.getContainerSize(); i++)
-        {
-            ItemStack itemStack = containerCrafting.getItem(i);
-            if(itemStack == null)
-            {
-                continue;
-            }
-            containerCrafting.removeItem(i, 1);
-            if(itemStack.getItem().hasContainerItem())
-            {
-                containerCrafting.setItem(i, new ItemStack(itemStack.getItem().getContainerItem()));
-            }
-        }
-        return returnStack;
-    }
-
     @Override
     public ItemStack getCraftingResult(ContainerCrafting containerCrafting)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/ConsumedFood.java b/game/core/src/main/java/net/minecraft/core/entity/ConsumedFood.java
index 1529a76ea..06bc29485 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/ConsumedFood.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/ConsumedFood.java
@@ -1,41 +1,46 @@
 package net.minecraft.core.entity;
 
 import net.minecraft.core.item.ItemFood;
+import net.minecraft.core.item.ItemStack;
 import org.jetbrains.annotations.NotNull;
 
 public class ConsumedFood {
     private final @NotNull Mob entity;
-    private final @NotNull ItemFood food;
+    private final @NotNull ItemStack stack;
+    private final @NotNull ItemFood foodItem;
     private int healRemaining;
     private int tickCounter = 0;
 
-    public ConsumedFood(@NotNull Mob entity, @NotNull ItemFood food) {
+    public ConsumedFood(@NotNull Mob entity, @NotNull ItemStack stack) {
         this.entity = entity;
-        this.food = food;
+        this.stack = stack;
 
-        this.healRemaining = food.getHealAmount();
+        this.foodItem = (ItemFood) stack.getItem();
+
+        this.healRemaining = this.foodItem.getHealAmount(this.stack);
     }
 
-    public void addFood() {
-        healRemaining += food.getHealAmount();
+    public void addFood(@NotNull ItemStack additionalStack) {
+        this.healRemaining += this.foodItem.getHealAmount(additionalStack);
     }
 
-    public int getHealRemaining(){
+    public int getHealRemaining() {
         return this.healRemaining;
     }
 
     public boolean isFinished() {
-        return healRemaining <= 0;
+        return this.healRemaining <= 0;
     }
 
     public void tick() {
         if (isFinished()) return;
 
-        tickCounter++;
-        if (tickCounter >= food.getTicksPerHeal()) {
-            tickCounter = 0;
-            healRemaining--;
-            entity.heal(1);
+        this.tickCounter++;
+
+        if (this.tickCounter >= this.foodItem.getTicksPerHeal(this.stack)) {
+            this.tickCounter = 0;
+            this.healRemaining--;
+            this.entity.heal(1);
         }
     }
-}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index e857d5465..6b58551ce 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -40,7 +40,7 @@ public abstract class Mob extends Entity {
     public static boolean SPAWN_NO_AI = false;
     public static final int DATA_VARIANT = 1;
     public static final int DATA_HEALTH = 2;
-    protected @NotNull Map<ItemFood, ConsumedFood> consumedFood = new HashMap<>();
+    protected Map<String, ConsumedFood> consumedFood = new HashMap<>();
     public int heartsHalvesLife;
     //    public float timeOffs;
 //    public float rotA;
@@ -318,15 +318,15 @@ public abstract class Mob extends Entity {
 
             }
         }
-        List<ItemFood> finishedFood = new ArrayList<>();
-        for (Map.Entry<ItemFood, ConsumedFood> entry : this.consumedFood.entrySet()) {
+        List<String> finishedFood = new ArrayList<>();
+        for (Map.Entry<String, ConsumedFood> entry : this.consumedFood.entrySet()) {
             entry.getValue().tick();
             if (entry.getValue().isFinished()) {
                 finishedFood.add(entry.getKey());
             }
         }
-        for (ItemFood food : finishedFood) {
-            this.consumedFood.remove(food);
+        for (String foodKey : finishedFood) {
+            this.consumedFood.remove(foodKey);
         }
         this.prevRotationUnused = this.unusedRotation1;
         this.yBodyRotO = this.yBodyRot;
@@ -480,15 +480,20 @@ public abstract class Mob extends Entity {
         return totalHealingRemaining;
     }
 
-    public void eatFood(ItemFood food) {
-        if (food == null) return;
-        if (food.getTicksPerHeal() == 0 || this.world.getGameRuleValue(GameRules.INSTANT_HEALING)) {
-            heal(food.getHealAmount());
+    public void eatFood(ItemStack stack) {
+        if (stack == null || !(stack.getItem() instanceof ItemFood)) return;
+
+        ItemFood foodItem = (ItemFood) stack.getItem();
+
+        if (foodItem.getTicksPerHeal(stack) == 0 || this.world.getGameRuleValue(GameRules.INSTANT_HEALING)) {
+            heal(foodItem.getHealAmount(stack));
         } else {
-            if (this.consumedFood.containsKey(food)) {
-                this.consumedFood.get(food).addFood();
+            String key = stack.getItemKey();
+
+            if (this.consumedFood.containsKey(key)) {
+                this.consumedFood.get(key).addFood(stack);
             } else {
-                this.consumedFood.put(food, new ConsumedFood(this, food));
+                this.consumedFood.put(key, new ConsumedFood(this, stack));
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java
index 7ea0ed3d0..12e6eb0e4 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java
@@ -1,11 +1,10 @@
 package net.minecraft.core.entity.animal;
 
 import net.minecraft.core.WeightedRandomLootObject;
-import net.minecraft.core.entity.AgedMob;
-import net.minecraft.core.entity.MobAge;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemBucket;
+import net.minecraft.core.item.ItemBucketSteel;
 import net.minecraft.core.item.Items;
-import net.minecraft.core.item.ItemBucketEmpty;
 import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.item.tag.ItemTags;
@@ -80,14 +79,14 @@ public class MobCow
     }
 
     @Override
-	public boolean interact(@NotNull Player player)
-    {
+    public boolean interact(@NotNull Player player) {
         ItemStack itemstack = player.inventory.getCurrentItem();
-        if(itemstack != null && itemstack.itemID == Items.BUCKET.id)
-        {
-            ItemBucketEmpty.useBucket(player, new ItemStack(Items.BUCKET_MILK));
+
+        if (itemstack != null && itemstack.getItem() instanceof ItemBucket) {
+            ItemBucket.useBucket(itemstack, player, this.world, ItemBucket.STATE_MILK);
             return true;
         }
+
         return super.interact(player);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index c7c69cf40..a4665d0a3 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -656,7 +656,7 @@ public class MobWolf
                             player.inventory.setItem(player.inventory.getCurrentSlot(), null);
                         }
                     }
-                    heal(itemfood.getHealAmount());
+                    heal(itemfood.getHealAmount(itemstack));
                     return true;
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
index 0dec555e9..b9d2ce69d 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
@@ -4,6 +4,9 @@ import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.projectile.ProjectileSnowball;
+import net.minecraft.core.item.ItemBucket;
+import net.minecraft.core.item.ItemBucketSteel;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.world.World;
@@ -103,11 +106,13 @@ public class MobSnowman extends MobMonster
     }
 
     @Override
-    protected void dropDeathItems()
-    {
-        if (random.nextInt(1000) == 0){
-            dropItem(Items.BUCKET_ICECREAM.id, 1);
+    protected void dropDeathItems() {
+        if (random.nextInt(1000) == 0) {
+            dropItem(ItemBucket.createItemStack(Items.BUCKET_IRON, ItemBucket.STATE_ICECREAM, 1), 0.0F);
+        } else if (random.nextInt(8192) == 0) {
+            dropItem(ItemBucket.createItemStack(Items.BUCKET_STEEL, ItemBucket.STATE_ICECREAM, 3), 0.0F);
         }
+
         super.dropDeathItems();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index ad5c30688..6a57f5029 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -35,6 +35,7 @@ import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.EnumSleepStatus;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemBucket;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.tool.ItemToolSword;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
index 09b9cfc3e..fabb99dc7 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
@@ -802,11 +802,11 @@ public class EntityMinecart extends Entity implements Container {
                 break;
             case FURNACE_CART:
                 ItemStack itemstack = player.inventory.getCurrentItem();
-                if (itemstack != null && LookupFuelFurnace.instance.getFuelYield(itemstack.itemID) > 0 && itemstack.consumeItem(player)) {
+                if (itemstack != null && LookupFuelFurnace.instance.getFuelYield(itemstack) > 0 && itemstack.consumeItem(player)) {
                     if (itemstack.stackSize <= 0) {
                         player.inventory.setItem(player.inventory.getCurrentSlot(), null);
                     }
-                    setFuel(getFuel() + MathHelper.round(((LookupFuelFurnace.instance.getFuelYield(itemstack.itemID) / 1600F) * 1200)));
+                    setFuel(getFuel() + MathHelper.round(((LookupFuelFurnace.instance.getFuelYield(itemstack) / 1600F) * 1200)));
                 }
                 this.xPush = this.x - player.x;
                 this.zPush = this.z - player.z;
